#include "stdafx.h"
#include "shelexec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


class CMyCommandLineInfo : public CCommandLineInfo
{
public:
//Constructors / Destructors
  CMyCommandLineInfo();

//Methods
  void ParseParam(LPCTSTR lpszParam, BOOL bFlag, BOOL bLast);

//Data
  CString m_sVerb;
  int m_nCmdShow;
};

CMyCommandLineInfo::CMyCommandLineInfo()
{
  m_nCmdShow = SW_SHOW;
}

void CMyCommandLineInfo::ParseParam(LPCTSTR lpszParam, BOOL bFlag, BOOL bLast)
{
  if (bFlag)
  {
    CString sParam(lpszParam);
    sParam.MakeUpper();
    int nFind = sParam.Find(_T("SHOWCMD"));
    int nLength = sParam.GetLength();
    if (nFind == 0 && nLength > 8)
    {
      CString sShowVal(sParam.Right(nLength - 8)); 
      m_nCmdShow = _ttoi(sShowVal);
    }
    else
    {
      nFind = sParam.Find(_T("VERB"));
      int nLength = sParam.GetLength();
      if (nFind == 0 && nLength > 5)
        m_sVerb = sParam.Right(nLength - 5); 
      else
        CCommandLineInfo::ParseParam(lpszParam, bFlag, bLast);
    }
  }
  else
    CCommandLineInfo::ParseParam(lpszParam, bFlag, bLast);
}


BEGIN_MESSAGE_MAP(CShelExecApp, CWinApp)
	//{{AFX_MSG_MAP(CShelExecApp)
	//}}AFX_MSG
END_MESSAGE_MAP()

CShelExecApp::CShelExecApp()
{
}

CShelExecApp theApp;

BOOL CShelExecApp::InitInstance()
{
  //Parse the command line
	CMyCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
  if (cmdInfo.m_strFileName.IsEmpty())
  {
    AfxMessageBox(_T("Usage: ShelExec [/Verb:Value] [/ShowCmd:Value] DocumentFile"));
    return FALSE;
  }

  //Call ShellExecute
  HINSTANCE hInstance = 0;
  if (cmdInfo.m_sVerb.GetLength())
    hInstance = ShellExecute(NULL, cmdInfo.m_sVerb, cmdInfo.m_strFileName, NULL, NULL, cmdInfo.m_nCmdShow);  
  else
    hInstance = ShellExecute(NULL, NULL, cmdInfo.m_strFileName, NULL, NULL, cmdInfo.m_nCmdShow);  
  if (hInstance <= (HINSTANCE) 32)
  {
    CString sMsg;
    sMsg.Format(_T("Failed to run \"%s\", Error: %d"), cmdInfo.m_strFileName, GetLastError());
    AfxMessageBox(sMsg);
  }
  
	return FALSE;
}

